
clear
clearvars -global
 
global Smad_Bin  Smad_Dis Snail1_Bin  Snail1_Dis   Teff 
global ExpTime 
DataPointNum=5; 

load('Exp_SmadSnail.mat') 

ExpTime=[0 8 12 24 48];

Smad_Bin=0:0.1:100;
Smad_Dis(1,:)=hist(Smadctrl,Smad_Bin)/length(Smadctrl);
Smad_Dis(2,:)=hist(SmadH8,Smad_Bin)/length(SmadH8);
Smad_Dis(3,:)=hist(SmadH12_conti,Smad_Bin)/length(SmadH12_conti);
Smad_Dis(4,:)=hist(SmadH24_conti,Smad_Bin)/length(SmadH24_conti);
Smad_Dis(5,:)=hist(SmadH48_conti,Smad_Bin)/length(SmadH48_conti);

Snail1_Bin=0:0.2:100;
Snail1_Dis(1,:)=hist(Snailctrl,Snail1_Bin)/length(Snailctrl); 
Snail1_Dis(2,:)=hist(SnailH8,Snail1_Bin)/length(SnailH8); 
Snail1_Dis(3,:)=hist(SnailH12_conti,Snail1_Bin)/length(SnailH12_conti); 
Snail1_Dis(4,:)=hist(SnailH24_conti,Snail1_Bin)/length(SnailH24_conti); 
Snail1_Dis(5,:)=hist(SnailH48_conti,Snail1_Bin)/length(SnailH48_conti); 
 

global Smad_Mean Snailmean   
Smad_Mean=[mean(Smadctrl) mean(SmadH8) mean(SmadH12_conti) mean(SmadH24_conti) mean(SmadH48_conti) ]/mean(Smadctrl);
Snailmean=[mean(Snailctrl) mean(SnailH8) mean(SnailH12_conti) mean(SnailH24_conti) mean(SnailH48_conti)]/mean(Snailctrl) ;
   
global Smad_max Snail_max

[ a, index]=max(Smad_Dis');
Smad_max=Smad_Bin(index);
[a, index ]=max(Snail1_Dis'); 
Snail_max=Snail1_Bin(index);
 
ParaInit
global plotflag
plotflag=0;

global T  
global stepsToDiscard accepts steps 
global FittingScore FittingScoreBEST
 
global SimSmad0 SimSnail0

SimSmad0=ones(1,length(ExpTime))*0.01;
SimSnail0=ones(1,length(ExpTime))*0.01; 
stepsToDiscard=100;
accepts=0; steps=0;
 

Teff=1;

ParaInit
%initial
TGF=0;
% options = odeset('AbsTol',1e-9);
sol=ode15s(@Fig1_ODE,[0 100000],[0 0 0 0 0 0]);% ,options);
y0=sol.y(:,end);
%TGF_induction
TGF=4;
sol=ode15s(@Fig1_ODE,[0 50],y0);% ,options);  
subplot(2,2,1) 
plot(sol.x ,sol.y(1,:),'LineWidth',4)
hold on 
plot(ExpTime, Smad_max,'o','MarkerSize',10) 
% plot(ExpTime, Smad_Mean,'o','MarkerSize',10) 
xlabel('Time (h)')
ylabel('Smad23')

subplot(2,2,2) 
plot(sol.x ,sol.y(4,:),'LineWidth',4)
hold on 
plot(ExpTime, Snail_max,'o','MarkerSize',10) 
% plot(ExpTime, Snailmean,'o','MarkerSize',10) 
xlabel('Time (h)')
ylabel('Snail1')
SimSmad1=deval(ExpTime,sol,1);  
SimSnail1=deval(ExpTime,sol,4); 
FittingScore=Fitscore(SimSmad1,SimSnail1,Teff)
FittingScoreBEST=FittingScore;
%%
stepsToDiscard=100;
Stepnum=100;

T0=1;
T=T0; 

rng('shuffle')
global fileID_ParaGood fileID_Smadgood fileID_Snailgood fileID_ScoreGood
fileID_ParaGood = fopen('ParaGood.txt','w');
fileID_Smadgood = fopen('Smadgood.txt','w');
fileID_Snailgood = fopen('Snailgood.txt','w');
fileID_ScoreGood = fopen('ScoreGood.txt','w'); 

for i=1:Stepnum  % 100000 for 5days
 
    i
    MonteCarloStep
%     if mod(i,100)==0
% %         T=T0-(T0-1)*i/Stepnum;
%         save Results100000.mat ParaGood Smadgood Snailgood ScoreGood
%     end 
    if mod(i,100)==0 
        fclose(fileID_ParaGood);
        fclose(fileID_Smadgood);
        fclose(fileID_Snailgood);
        fclose(fileID_ScoreGood);
        
        fileID_ParaGood = fopen('ParaGood.txt','a');
        fileID_Smadgood = fopen('Smadgood.txt','a');
        fileID_Snailgood = fopen('Snailgood.txt','a');
        fileID_ScoreGood = fopen('ScoreGood.txt','a'); 
    end  
end

fclose(fileID_ParaGood);
fclose(fileID_Smadgood);
fclose(fileID_Snailgood);
fclose(fileID_ScoreGood);
saveas(gca, 'fig.fig')
%%

 
