
clear
clearvars -global
 
global Smad_Bin  Smad_Dis Snail1_Bin  Snail1_Dis GLI1_Bin  GLI1_Dis Teff 

DataPointNum=5; 

load('Exp_SmadSnail.mat') 
load('Exp_Gli.mat') 

Smad_Bin=0:0.1:100;
Smad_Dis(1,:)=hist(Smadctrl,Smad_Bin)/length(Smadctrl);
Smad_Dis(2,:)=hist(SmadH8,Smad_Bin)/length(SmadH8);
Smad_Dis(3,:)=hist(SmadH12_conti,Smad_Bin)/length(SmadH12_conti);
Smad_Dis(4,:)=hist(SmadH24_conti,Smad_Bin)/length(SmadH24_conti);
Smad_Dis(5,:)=hist(SmadH48_conti,Smad_Bin)/length(SmadH48_conti);

Snail1_Bin=0:0.2:100;
Snail1_Dis(1,:)=hist(Snailctrl,Snail1_Bin)/length(Snailctrl); 
Snail1_Dis(2,:)=hist(SnailH8,Snail1_Bin)/length(SnailH8); 
Snail1_Dis(3,:)=hist(SnailH12_conti,Snail1_Bin)/length(SnailH12_conti); 
Snail1_Dis(4,:)=hist(SnailH24_conti,Snail1_Bin)/length(SnailH24_conti); 
Snail1_Dis(5,:)=hist(SnailH48_conti,Snail1_Bin)/length(SnailH48_conti); 
  

GLI1_Bin=0:0.2:100;
GLI1_Dis(1,:)=hist(Glictrl,GLI1_Bin)/length(Glictrl); 
GLI1_Dis(2,:)=hist(GliH8,GLI1_Bin)/length(GliH8); 
GLI1_Dis(3,:)=hist(GliH12_conti,GLI1_Bin)/length(GliH12_conti); 
GLI1_Dis(4,:)=hist(GliH24_conti,GLI1_Bin)/length(GliH24_conti); 
GLI1_Dis(5,:)=hist(GliH48_conti,GLI1_Bin)/length(GliH48_conti); 


global Smad_max Snail_max Gli_max

[ a, index]=max(Smad_Dis');
Smad_max=Smad_Bin(index);
[a, index ]=max(Snail1_Dis'); 
Snail_max=Snail1_Bin(index);
[a, index ]=max(GLI1_Dis'); 
Gli_max=GLI1_Bin(index);


global Smad_Mean Snailmean  Gli_mean ExpTime
load('Exp_SmadSnail.mat') 
load Exp_Gli.mat
ExpTime=[0 8 12 24 48];
Smad_Mean=[mean(Smadctrl) mean(SmadH8) mean(SmadH12_conti) mean(SmadH24_conti) mean(SmadH48_conti) ]/mean(Smadctrl);
Snailmean=[mean(Snailctrl) mean(SnailH8) mean(SnailH12_conti) mean(SnailH24_conti) mean(SnailH48_conti)]/mean(Snailctrl);
Gli_mean=[mean(Glictrl), mean(GliH8),   mean(GliH12_conti),   mean(GliH24_conti),   mean(GliH48_conti) ]/mean(Glictrl);
 
Smad_std=[std(Smadctrl) std(SmadH8) std(SmadH12_conti) std(SmadH24_conti) std(SmadH48_conti) ]/mean(Smadctrl);
Snailstd=[std(Snailctrl) std(SnailH8) std(SnailH12_conti) std(SnailH24_conti) std(SnailH48_conti)]/mean(Snailctrl) ;
Gli_std=[std(Glictrl), std(GliH8), std(GliH12_conti),   std(GliH24_conti),   std(GliH48_conti) ]/mean(Glictrl)  ;
 
global plotflag
plotflag=0;
 
global stepsToDiscard accepts steps 
global FittingScore FittingScoreBEST
global SimSmad0 SimGli0 SimSnail0

SimSmad0=ones(1,length(ExpTime))*100;
SimGli0=ones(1,length(ExpTime))*100;
SimSnail0=ones(1,length(ExpTime))*100; 
stepsToDiscard=0;
accepts=0; steps=0;

Teff=1;

ParaInit 

% initial
TGF=0;
% options = odeset('AbsTol',1e-9);
sol=ode15s(@Fig2_ODE,[0 100000],[0 0 0 0 0 0 0]);% ,options);
y0=sol.y(:,end);
%TGF_induction
TGF=4;
sol=ode15s(@Fig2_ODE,[0 50],y0);% ,options); 
subplot(3,2,1) 
plot(sol.x,sol.y(1,:),'r','linewidth',2)
hold on 
% plot(ExpTime/5, Smad_max,'ko','MarkerSize',10,'linewidth',2) 

subplot(3,2,3) 
plot(sol.x,sol.y(3,:),'r','linewidth',2)
hold on 
% plot(ExpTime/5, Gli_max,'ko','MarkerSize',10,'linewidth',2) 

subplot(3,2,5)  
plot(sol.x,sol.y(5,:),'r','linewidth',2)
hold on 
% plot(ExpTime/5, Snail_max,'ko','MarkerSize',10,'linewidth',2)  
 %%
subplot(3,2,1) 
hold on
violin(Smadctrl/mean(Smadctrl),'x',[0 1] ,'medc','k-','mc',[],'bw',.2)
violin(SmadH8/mean(Smadctrl),'x',[8 1] ,'medc','k-','mc',[],'bw',.2)
violin(SmadH12_conti/mean(Smadctrl),'x',[12 1] ,'medc','k-','mc',[],'bw',.2)
violin(SmadH24_conti/mean(Smadctrl),'x',[24 1] ,'medc','k-','mc',[],'bw',.2)
violin(SmadH48_conti/mean(Smadctrl),'x',[48  1],'medc','k-','mc',[],'bw',.2)
xlabel('Time (h)') 
ylabel('[nuclear pSMAD2/3]')
xlim([-2 50])
ylim([0 8])
set(gca,'TickLength',[0.01 0.025]) 

subplot(3,2,5)
hold on
violin(Snailctrl/mean(Snailctrl),'x',[0 1] ,'medc','k-','mc',[],'bw',.15)
violin(SnailH8/mean(Snailctrl),'x',[8 1] ,'medc','k-','mc',[],'bw',.15)
violin(SnailH12_conti/mean(Snailctrl),'x',[12 1] ,'medc','k-','mc',[],'bw',.15)
violin(SnailH24_conti/mean(Snailctrl),'x',[24 1],'medc','k-','mc',[],'bw',.15)
violin(SnailH48_conti/mean(Snailctrl),'x',[48 1] ,'medc','k-','mc',[],'bw',.15)

xlabel('Time (h)')
ylabel('[nuclear SNAIL1]') 
xlim([-2 50])
ylim([0 6]) 

 

subplot(3,2,3)
hold on
violin(Glictrl/mean(Glictrl),'x',[0 1],'medc','k-','mc',[],'bw',.15)
violin(GliH8/mean(Glictrl),'x',[8 1],'medc','k-','mc',[],'bw',.15)
violin(GliH12_conti/mean(Glictrl),'x',[12 1],'medc','k-','mc',[],'bw',.15)
violin(GliH24_conti/mean(Glictrl),'x',[24 1],'medc','k-','mc',[],'bw',.15)
violin(GliH48_conti/mean(Glictrl),'x',[48 1],'medc','k-','mc',[],'bw',.15)
xlim([-2 50]) 
ylabel('[nuclear SNAIL1]')
ylim([0 8]) 
set(gca,'TickLength',[0.01 0.025])
 