%%
clc
clear
global Smad_Bin  Smad_Dis Snail1_Bin  Snail1_Dis GLI1_Bin  GLI1_Dis 

global TGF  TGF_Duration TGF_decay

DataPointNum=5; 

load('Exp_SmadSnail.mat') 
load('Exp_Gli.mat') 

Smad_Bin=0:0.1:100;
Smad_Dis=zeros(5,1001);
Smad_Dis(1,:)=hist(Smadctrl,Smad_Bin)/length(Smadctrl);
Smad_Dis(2,:)=hist(SmadH8,Smad_Bin)/length(SmadH8);
Smad_Dis(3,:)=hist(SmadH12_conti,Smad_Bin)/length(SmadH12_conti);
Smad_Dis(4,:)=hist(SmadH24_conti,Smad_Bin)/length(SmadH24_conti);
Smad_Dis(5,:)=hist(SmadH48_conti,Smad_Bin)/length(SmadH48_conti);

Snail1_Bin=0:0.2:100;
Snail1_Dis=zeros(5,501);
Snail1_Dis(1,:)=hist(Snailctrl,Snail1_Bin)/length(Snailctrl); 
Snail1_Dis(2,:)=hist(SnailH8,Snail1_Bin)/length(SnailH8); 
Snail1_Dis(3,:)=hist(SnailH12_conti,Snail1_Bin)/length(SnailH12_conti); 
Snail1_Dis(4,:)=hist(SnailH24_conti,Snail1_Bin)/length(SnailH24_conti); 
Snail1_Dis(5,:)=hist(SnailH48_conti,Snail1_Bin)/length(SnailH48_conti); 
  

GLI1_Bin=0:0.2:100;
GLI1_Dis=zeros(5,501);
GLI1_Dis(1,:)=hist(Glictrl,GLI1_Bin)/length(Glictrl); 
GLI1_Dis(2,:)=hist(GliH8,GLI1_Bin)/length(GliH8); 
GLI1_Dis(3,:)=hist(GliH12_conti,GLI1_Bin)/length(GliH12_conti); 
GLI1_Dis(4,:)=hist(GliH24_conti,GLI1_Bin)/length(GliH24_conti); 
GLI1_Dis(5,:)=hist(GliH48_conti,GLI1_Bin)/length(GliH48_conti); 

 
 
global Smad_max Snail_max Gli_max

[ a, index]=max(Smad_Dis');
Smad_max=Smad_Bin(index);
[a, index ]=max(Snail1_Dis'); 
Snail_max=Snail1_Bin(index);
[a, index ]=max(GLI1_Dis'); 
Gli_max=GLI1_Bin(index);

  
global Smad_Mean Snailmean  Gli_mean ExpTime Teff
global FittingScore FittingScoreBEST
Teff=1
load('Exp_SmadSnail.mat') 
load Exp_Gli.mat
ExpTime=[0 8 12 24 48]; 
Smad_Mean=[mean(Smadctrl) mean(SmadH8) mean(SmadH12_conti) mean(SmadH24_conti) mean(SmadH48_conti) ]/mean(Smadctrl);
Snailmean=[mean(Snailctrl) mean(SnailH8) mean(SnailH12_conti) mean(SnailH24_conti) mean(SnailH48_conti)]/mean(Snailctrl);
Gli_mean=[mean(Glictrl), mean(GliH8),   mean(GliH12_conti),   mean(GliH24_conti),   mean(GliH48_conti) ]/mean(Glictrl);
 
Smad_std=[std(Smadctrl) std(SmadH8) std(SmadH12_conti) std(SmadH24_conti) std(SmadH48_conti) ]/mean(Smadctrl);
Snailstd=[std(Snailctrl) std(SnailH8) std(SnailH12_conti) std(SnailH24_conti) std(SnailH48_conti)]/mean(Snailctrl) ;
Gli_std=[std(Glictrl), std(GliH8), std(GliH12_conti),   std(GliH24_conti),   std(GliH48_conti) ]/mean(Glictrl)  ;
  
ParaInit

%initial
TGF=0;TGF_Duration=0;
% options = odeset('AbsTol',1e-9);
sol=ode15s(@FullModel_Pulse,[0 100000],[0 0 0 0 0 0 0]);% ,options);
y0=sol.y(:,end) 
%TGF_induction
TGF=4; TGF_Duration=51;
sol=ode15s(@FullModel_Pulse,[0 51],y0);% ,options); 
% plot(sol.x,sol.y)
  subplot1(3,2,1) 
    hold off
    plot(sol.x,sol.y(1,:))
    hold on 
%     plot(ExpTime, Smad_Mean,'o','MarkerSize',10) 
    plot(ExpTime, Smad_max,'o','MarkerSize',10) 
    
    
    a1=10; 
    b1=10;
    GSKc= TGF*kgskc*(1-exp(-sol.x/a1)).*exp(-(sol.x-b1)/a1);
    GLIt=sol.y(3,:);     
    Gli1=Glin_solve(GLIt,GSKc);
    
    subplot1(3,2,3) 
    hold off
    plot(sol.x,Gli1)
    hold on 
    plot(sol.x,GLIt)
%     plot(sol.x,GSKc)
%     plot(ExpTime, Gli_mean,'o','MarkerSize',10) 
    plot(ExpTime, Gli_max,'o','MarkerSize',10) 
    ylim([0 5])
    
    subplot1(3,2,5)  
    hold off
    plot(sol.x,sol.y(5,:))
    hold on 
%     plot(ExpTime, Snailmean,'o','MarkerSize',10) 
    plot(ExpTime, Snail_max,'o','MarkerSize',10)  
 
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
  
ParaInit
% initial
TGF=0;
TGF_Duration=0;
options = odeset('AbsTol',1e-9);
sol=ode15s(@FullModel_Pulse,[0 100000],[0 0 0 0 0 0 0],options);
y0=sol.y(:,end) 
TGF_decay=.025
Tmax=172;  
 

for i=[2 4 15 Tmax]

    TGF_Duration=i*1; 
    TGF=4; 
    options=odeset('RelTol',1e-9,'AbsTol',1e-9);
    sol=ode15s(@FullModel_Pulse,[0 Tmax],y0,options); 
    subplot1(3,2,1)  
    plot(sol.x,sol.y(1,:))
    hold on 
%     plot(ExpTime, Smad_Mean,'o','MarkerSize',10) 
    plot(ExpTime, Smad_max,'o','MarkerSize',10) 

    TGF_t=TGF*exp(-TGF_decay*(sol.x-TGF_Duration));
    TGF_t(TGF_t>4)=4;
    subplot1(3,2,2)  
    plot(sol.x,TGF_t)
    hold on

    a1=10; 
    b1=10;
    GSKc=TGF_t*kgskc.*(1-exp(-sol.x/a1)).*exp(-(sol.x-b1)/a1);
    GLIt=sol.y(3,:);     
    Gli1=Glin_solve(GLIt,GSKc);



    subplot1(3,2,3)  
    plot(sol.x,Gli1)
    hold on 
%         plot(sol.x,GLIt)
%     plot(sol.x,GSKc)
%     plot(ExpTime, Gli_mean,'o','MarkerSize',10) 
    plot(ExpTime, Gli_max,'o','MarkerSize',10) 

    subplot1(3,2,5)   
    plot(sol.x,sol.y(5,:))
    hold on 
%     plot(ExpTime, Snailmean,'o','MarkerSize',10) 
    plot(ExpTime, Snail_max,'o','MarkerSize',10)  

end  
% legend('1h Pulse','2h Pulse','4h Pulse','Cont')
 %%
figure
TGF_decay=.025;
TGF=4;  
Tmax=72;
delta_TGF_Duration=.1;
for i=1:101
    
    TGF_Duration=i*delta_TGF_Duration;

    options=odeset('RelTol',1e-9,'AbsTol',1e-9);
    sol1=ode15s(@FullModel_Pulse,[0 Tmax],y0,options);  
  
    Smad_Record(i,:)=deval(sol1,0:Tmax,1) ;
    
    TGF_t=TGF*exp(-TGF_decay*((0:Tmax)-TGF_Duration));
    TGF_t(TGF_t>TGF)=TGF;
    
    a1=10; 
    b1=10;
    GSKc=TGF_t*kgskc.*(1-exp(-(0:Tmax)/a1)).*exp(-((0:Tmax)-b1)/a1);
    GLIt=deval(sol1,0:Tmax,3) ;     
    Gli1=Glin_solve(GLIt,GSKc); 
%         
%     plot(0:Tmax,Gli1)
%     hold on
    
    Gli_Record(i,:)=Gli1;
    Snail_Record(i,:)=deval(sol1,0:Tmax,5);
  
end 

subplot1(6,3,4)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Smad_Record)
    title('[nuclear pSMAD2/3]')
    xlabel('Time (h)')
    ylabel('TGF-\beta Duration')
    xlim([0 Tmax])
    colormap jet
subplot1(6,3,5)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Gli_Record)
    title('[nuclear GLI1]')
    xlabel('Time (h)')
%     ylabel('TGF-\beta Duration')
    xlim([0 Tmax])
    colormap jet
    caxis([ 1 4])
subplot1(6,3,6)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Snail_Record)
    title('[nuclear SNAIL1]')
    xlabel('Time (h)')
%     ylabel('TGF-\beta Duration')
    xlim([0 Tmax])
    colormap jet
    caxis([ 1 2])
% subplot1(6,3,1)
%     plot(0:delta_TGF_Duration:100*delta_TGF_Duration,Smad_Record(:,end),'LineWidth',2,'Color',[0 0 0])
%  
%     xlabel('TGF-\beta Duration')
%     ylabel('[nuclear pSMAD2/3]_{ss}')
%     ylim([0 2])
% subplot1(6,3,2)
%     plot(0:delta_TGF_Duration:100*delta_TGF_Duration,Gli_Record(:,end),'LineWidth',2,'Color',[0 0 0])
%      xlabel('TGF-\beta Duration')
%     ylabel('[nuclear GLI1]_{ss}')
%     xlim([0 10])
% subplot1(6,3,3)
%     plot(0:delta_TGF_Duration:100*delta_TGF_Duration,Snail_Record(:,end),'LineWidth',2,'Color',[0 0 0])
%      xlabel('TGF-\beta Duration')
%     ylabel('[nuclear SNAIL1]_{ss}')
%     xlim([0 10])
    
%%
 