
clear
clearvars -global 

for MutationIndex=5

    ParaInit
    TGF_decay=.025;
 
    if MutationIndex==1
        kgskn=kgskn*0.8; % GSKn over 
%         GSKn0=1.2;
    elseif MutationIndex==2
%         GSKn0=.8;
        kgskn=kgskn*1.2; % GSKn under 
    elseif MutationIndex==3
        kgskc=1.2; % GSKc over
%         GSKc0=1.2;
    elseif MutationIndex==4
        kgskc=.5; % GSKc under
%         GSKc0=0 ;
    elseif MutationIndex==5
        k_gli0=k_gli0*1.2;  % GLI over
%         k_gli1=k_gli1*1.1;  % GLI down
    elseif MutationIndex==6
        k_gli0=k_gli0*0.5;  % GLI down
    elseif MutationIndex==7
        k_smadi=k_smadi*.8; % Smad-I d own
    end
 
    
    % initial
    TGF=0;
    TGF_Duration=1000;
    options = odeset('AbsTol',1e-9);
    sol=ode15s(@FullModel_Pulse,[0 100000],[0 0 0 0 0 0 0],options);
    y0=sol.y(:,end)  
    
    TGF=4; 
    Tmax=72;

    delta_TGF_Duration=.1;
    for i=1:101

        TGF_Duration=i*delta_TGF_Duration;

        options=odeset('RelTol',1e-9,'AbsTol',1e-9);
        sol1=ode15s(@FullModel_Pulse,[0 Tmax],y0,options);  

        Smad_Record(i,:)=deval(sol1,0:Tmax,1) ;

        TGF_t=TGF*exp(-TGF_decay*((0:Tmax)-TGF_Duration));
        TGF_t(TGF_t>TGF)=TGF;


        a1=10; 
        b1=10;
        GSKc=TGF_t*kgskc.*(1-exp(-(0:Tmax)/a1)).*exp(-((0:Tmax)-b1)/a1);
        GLIt=deval(sol1,0:Tmax,3) ;     
        Gli1=Glin_solve(GLIt,GSKc);
 

        Gli_Record(i,:)=Gli1;
        Snail_Record(i,:)=deval(sol1,0:Tmax,5);

    end 

    colormap jet
subplot1(7,3,(MutationIndex-1)*3+1)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Smad_Record)
%     caxis([1 3.5])
    if MutationIndex==1
    title('[nuclear pSMAD2/3]')
    else
    set(gca,'YTickLabel',{'','','','',''})
    end
    if MutationIndex==6
    xlabel('Time (h)')
    else
    set(gca,'XTickLabel',{'','','',''})
    end
    ylabel('TGF-\beta Duration') 
    xlim([0 Tmax])
    ylim([1 10])
subplot1(7,3,(MutationIndex-1)*3+2)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Gli_Record)

    caxis([ 1 4])
    if MutationIndex==1
    title('[nuclear GLI1]')
    else
    set(gca,'YTickLabel',{'','','','',''})
    end
    if MutationIndex==6
    xlabel('Time (h)')
    else
    set(gca,'XTickLabel',{'','','',''})
    end 
%     ylabel('TGF-\beta Duration')
    xlim([0 Tmax])
    ylim([1 10])
subplot1(7,3,(MutationIndex-1)*3+3)
imagesc(1:Tmax,0:delta_TGF_Duration:100*delta_TGF_Duration,Snail_Record)

    caxis([ .8 2])
    if MutationIndex==1
    title('[nuclear SNAIL1]')
    else
    set(gca,'YTickLabel',{'','','','',''})
    end
    
    if MutationIndex==6
    xlabel('Time (h)')
    else
    set(gca,'XTickLabel',{'','','',''})
    end
%     ylabel('TGF-\beta Duration')
    xlim([0 Tmax])
    ylim([1 10])
end    
 