%%
clc
clear
global Smad_Bin  Smad_Dis Snail1_Bin  Snail1_Dis GLI1_Bin  GLI1_Dis 

DataPointNum=5; 

load('Exp_SmadSnail.mat') 
load('Exp_Gli.mat') 

Smad_Bin=0:0.1:100;
Smad_Dis=zeros(5,1001);
Smad_Dis(1,:)=hist(Smadctrl,Smad_Bin)/length(Smadctrl);
Smad_Dis(2,:)=hist(SmadH8,Smad_Bin)/length(SmadH8);
Smad_Dis(3,:)=hist(SmadH12_conti,Smad_Bin)/length(SmadH12_conti);
Smad_Dis(4,:)=hist(SmadH24_conti,Smad_Bin)/length(SmadH24_conti);
Smad_Dis(5,:)=hist(SmadH48_conti,Smad_Bin)/length(SmadH48_conti);

Snail1_Bin=0:0.2:100;
Snail1_Dis=zeros(5,501);
Snail1_Dis(1,:)=hist(Snailctrl,Snail1_Bin)/length(Snailctrl); 
Snail1_Dis(2,:)=hist(SnailH8,Snail1_Bin)/length(SnailH8); 
Snail1_Dis(3,:)=hist(SnailH12_conti,Snail1_Bin)/length(SnailH12_conti); 
Snail1_Dis(4,:)=hist(SnailH24_conti,Snail1_Bin)/length(SnailH24_conti); 
Snail1_Dis(5,:)=hist(SnailH48_conti,Snail1_Bin)/length(SnailH48_conti); 
  

GLI1_Bin=0:0.2:100;
GLI1_Dis=zeros(5,501);
GLI1_Dis(1,:)=hist(Glictrl,GLI1_Bin)/length(Glictrl); 
GLI1_Dis(2,:)=hist(GliH8,GLI1_Bin)/length(GliH8); 
GLI1_Dis(3,:)=hist(GliH12_conti,GLI1_Bin)/length(GliH12_conti); 
GLI1_Dis(4,:)=hist(GliH24_conti,GLI1_Bin)/length(GliH24_conti); 
GLI1_Dis(5,:)=hist(GliH48_conti,GLI1_Bin)/length(GliH48_conti); 

 
 
global Smad_max Snail_max Gli_max

[ a, index]=max(Smad_Dis');
Smad_max=Smad_Bin(index);
[a, index ]=max(Snail1_Dis'); 
Snail_max=Snail1_Bin(index);
[a, index ]=max(GLI1_Dis'); 
Gli_max=GLI1_Bin(index);

  
global Smad_Mean Snailmean  Gli_mean ExpTime Teff
global FittingScore FittingScoreBEST
Teff=1
load('Exp_SmadSnail.mat') 
load Exp_Gli.mat
ExpTime=[0 8 12 24 48]; 
Smad_Mean=[mean(Smadctrl) mean(SmadH8) mean(SmadH12_conti) mean(SmadH24_conti) mean(SmadH48_conti) ]/mean(Smadctrl);
Snailmean=[mean(Snailctrl) mean(SnailH8) mean(SnailH12_conti) mean(SnailH24_conti) mean(SnailH48_conti)]/mean(Snailctrl);
Gli_mean=[mean(Glictrl), mean(GliH8),   mean(GliH12_conti),   mean(GliH24_conti),   mean(GliH48_conti) ]/mean(Glictrl);
 
Smad_std=[std(Smadctrl) std(SmadH8) std(SmadH12_conti) std(SmadH24_conti) std(SmadH48_conti) ]/mean(Smadctrl);
Snailstd=[std(Snailctrl) std(SnailH8) std(SnailH12_conti) std(SnailH24_conti) std(SnailH48_conti)]/mean(Snailctrl) ;
Gli_std=[std(Glictrl), std(GliH8), std(GliH12_conti),   std(GliH24_conti),   std(GliH48_conti) ]/mean(Glictrl)  ;
 
ParaInit

%initial
TGF=0;
% options = odeset('AbsTol',1e-9);
sol=ode15s(@FullModel,[0 100000],[0 0 0 0 0 0 0]);% ,options);
y0=sol.y(:,end) 
%TGF_induction
TGF=4;
sol=ode15s(@FullModel,[0 51],y0);% ,options); 
% plot(sol.x,sol.y)
  subplot(3,2,1) 
    hold off
    plot(sol.x,sol.y(1,:))
    hold on 
%     plot(ExpTime, Smad_Mean,'o','MarkerSize',10) 
    plot(ExpTime, Smad_max,'o','MarkerSize',10) 
    
    
    a1=10; 
    b1=10;
    GSKc=1+TGF/4*(1-exp(-sol.x/a1)).*exp(-(sol.x-b1)/a1);
    GLIt=sol.y(3,:);     
    Gli1=Glin_solve(GLIt,GSKc);
    
    subplot(3,2,3) 
    hold off
    plot(sol.x,Gli1)
    hold on 
    plot(sol.x,GLIt)
%     plot(sol.x,GSKc)
%     plot(ExpTime, Gli_mean,'o','MarkerSize',10) 
    plot(ExpTime, Gli_max,'o','MarkerSize',10) 
    ylim([0 5])
    
    subplot(3,2,5)  
    hold off
    plot(sol.x,sol.y(5,:))
    hold on 
%     plot(ExpTime, Snailmean,'o','MarkerSize',10) 
    plot(ExpTime, Snail_max,'o','MarkerSize',10)  

a1=10; 
b1=10;
a2=20; 
b2=20;

GSKc=1+TGF/4*(1-exp(-ExpTime/a1)).*exp(-(ExpTime-b1)/a1);
  
SimSmad1=deval(ExpTime,sol,1);  
SimGLIt=deval(ExpTime,sol,3);  
SimGli1=Glin_solve(SimGLIt,GSKc); 
SimSnail1=deval(ExpTime,sol,5); 
FittingScore=Fitscore(SimSmad1,SimSnail1,SimGli1) 
FittingScoreBEST=FittingScore 

%%
  
global plotflag
plotflag=1;
 
global stepsToDiscard accepts steps 
global SimSmad0 SimGli0 SimSnail0

SimSmad0=ones(1,length(ExpTime))*100;
SimGli0=ones(1,length(ExpTime))*100;
SimSnail0=ones(1,length(ExpTime))*100; 
stepsToDiscard=0;
accepts=0; steps=0;
 
FittingScore=0;
Stepnum=1000000;
 

rng('shuffle')
global fileID_ParaGood fileID_Smadgood fileID_Snailgood fileID_Gligood fileID_ScoreGood
fileID_ParaGood = fopen('ParaGood.txt','w');
fileID_Smadgood = fopen('Smadgood.txt','w');
fileID_Snailgood = fopen('Snailgood.txt','w');
fileID_Gligood = fopen('Gligood.txt','w');
fileID_ScoreGood = fopen('ScoreGood.txt','w'); 

for i=1:Stepnum  % 100000 for 5days
 
    i
    MonteCarloStep
%     if mod(i,100)==0
% %         T=T0-(T0-1)*i/Stepnum;
%         save Results100000.mat ParaGood Smadgood Snailgood ScoreGood
%     end 
    if mod(i,100)==0 
        fclose(fileID_ParaGood);
        fclose(fileID_Smadgood);
        fclose(fileID_Snailgood);
        fclose(fileID_ScoreGood);
        fclose(fileID_Gligood);
        
        fileID_ParaGood = fopen('ParaGood.txt','a');
        fileID_Smadgood = fopen('Smadgood.txt','a');
        fileID_Snailgood = fopen('Snailgood.txt','a');
        fileID_ScoreGood = fopen('ScoreGood.txt','a'); 
        fileID_Gligood= fopen('Gligood.txt','a'); 
    end  
end

fclose(fileID_ParaGood);
fclose(fileID_Smadgood);
fclose(fileID_Snailgood);
fclose(fileID_ScoreGood);
fclose(fileID_Gligood);

 